import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "kappctrl.k14s.io.v1alpha1.App";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "kappctrl.k14s.io/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "App"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "canceled": {
                    "type": "boolean",
                    "nullable": true
                },
                "cluster": {
                    "properties": {
                        "kubeconfigSecretRef": {
                            "properties": {
                                "key": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "name": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "namespace": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "deploy": {
                    "items": {
                        "properties": {
                            "kapp": {
                                "properties": {
                                    "delete": {
                                        "properties": {
                                            "rawOptions": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "inspect": {
                                        "properties": {
                                            "rawOptions": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "intoNs": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "mapNs": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    },
                                    "rawOptions": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "fetch": {
                    "items": {
                        "properties": {
                            "git": {
                                "properties": {
                                    "lfsSkipSmudge": {
                                        "type": "boolean",
                                        "nullable": true
                                    },
                                    "ref": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "refSelection": {
                                        "properties": {
                                            "semver": {
                                                "properties": {
                                                    "constraints": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "prereleases": {
                                                        "properties": {
                                                            "identifiers": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "secretRef": {
                                        "properties": {
                                            "name": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "subPath": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "url": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "helmChart": {
                                "properties": {
                                    "name": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "repository": {
                                        "properties": {
                                            "secretRef": {
                                                "properties": {
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            },
                                            "url": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "version": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "http": {
                                "properties": {
                                    "secretRef": {
                                        "properties": {
                                            "name": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "sha256": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "subPath": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "url": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "image": {
                                "properties": {
                                    "secretRef": {
                                        "properties": {
                                            "name": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "subPath": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "tagSelection": {
                                        "properties": {
                                            "semver": {
                                                "properties": {
                                                    "constraints": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "prereleases": {
                                                        "properties": {
                                                            "identifiers": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "url": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "imgpkgBundle": {
                                "properties": {
                                    "image": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "secretRef": {
                                        "properties": {
                                            "name": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "tagSelection": {
                                        "properties": {
                                            "semver": {
                                                "properties": {
                                                    "constraints": {
                                                        "type": "string",
                                                        "nullable": true
                                                    },
                                                    "prereleases": {
                                                        "properties": {
                                                            "identifiers": {
                                                                "items": {
                                                                    "type": "string"
                                                                },
                                                                "type": "array",
                                                                "nullable": true
                                                            }
                                                        },
                                                        "type": "object",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "inline": {
                                "properties": {
                                    "paths": {
                                        "additionalProperties": {
                                            "type": "string"
                                        },
                                        "type": "object",
                                        "properties": {},
                                        "nullable": true
                                    },
                                    "pathsFrom": {
                                        "items": {
                                            "properties": {
                                                "configMapRef": {
                                                    "properties": {
                                                        "directoryPath": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "secretRef": {
                                                    "properties": {
                                                        "directoryPath": {
                                                            "type": "string",
                                                            "nullable": true
                                                        },
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "path": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "noopDelete": {
                    "type": "boolean",
                    "nullable": true
                },
                "paused": {
                    "type": "boolean",
                    "nullable": true
                },
                "serviceAccountName": {
                    "type": "string",
                    "nullable": true
                },
                "syncPeriod": {
                    "type": "string",
                    "nullable": true
                },
                "template": {
                    "items": {
                        "properties": {
                            "cue": {
                                "properties": {
                                    "inputExpression": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "outputExpression": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "paths": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    },
                                    "valuesFrom": {
                                        "items": {
                                            "properties": {
                                                "configMapRef": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "downwardAPI": {
                                                    "properties": {
                                                        "items": {
                                                            "items": {
                                                                "properties": {
                                                                    "fieldPath": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "kappControllerVersion": {
                                                                        "properties": {
                                                                            "version": {
                                                                                "type": "string",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "kubernetesAPIs": {
                                                                        "properties": {
                                                                            "groupVersions": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "kubernetesVersion": {
                                                                        "properties": {
                                                                            "version": {
                                                                                "type": "string",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "path": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "secretRef": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "helmTemplate": {
                                "properties": {
                                    "kubernetesAPIs": {
                                        "properties": {
                                            "groupVersions": {
                                                "items": {
                                                    "type": "string"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "kubernetesVersion": {
                                        "properties": {
                                            "version": {
                                                "type": "string",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "name": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "namespace": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "path": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "valuesFrom": {
                                        "items": {
                                            "properties": {
                                                "configMapRef": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "downwardAPI": {
                                                    "properties": {
                                                        "items": {
                                                            "items": {
                                                                "properties": {
                                                                    "fieldPath": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "kappControllerVersion": {
                                                                        "properties": {
                                                                            "version": {
                                                                                "type": "string",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "kubernetesAPIs": {
                                                                        "properties": {
                                                                            "groupVersions": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "kubernetesVersion": {
                                                                        "properties": {
                                                                            "version": {
                                                                                "type": "string",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "path": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "secretRef": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "jsonnet": {
                                "type": "object",
                                "properties": {},
                                "nullable": true
                            },
                            "kbld": {
                                "properties": {
                                    "paths": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "kustomize": {
                                "type": "object",
                                "properties": {},
                                "nullable": true
                            },
                            "sops": {
                                "properties": {
                                    "age": {
                                        "properties": {
                                            "privateKeysSecretRef": {
                                                "properties": {
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "paths": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    },
                                    "pgp": {
                                        "properties": {
                                            "privateKeysSecretRef": {
                                                "properties": {
                                                    "name": {
                                                        "type": "string",
                                                        "nullable": true
                                                    }
                                                },
                                                "type": "object",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            },
                            "ytt": {
                                "properties": {
                                    "fileMarks": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    },
                                    "ignoreUnknownComments": {
                                        "type": "boolean",
                                        "nullable": true
                                    },
                                    "inline": {
                                        "properties": {
                                            "paths": {
                                                "additionalProperties": {
                                                    "type": "string"
                                                },
                                                "type": "object",
                                                "properties": {},
                                                "nullable": true
                                            },
                                            "pathsFrom": {
                                                "items": {
                                                    "properties": {
                                                        "configMapRef": {
                                                            "properties": {
                                                                "directoryPath": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "name": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        },
                                                        "secretRef": {
                                                            "properties": {
                                                                "directoryPath": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                },
                                                                "name": {
                                                                    "type": "string",
                                                                    "nullable": true
                                                                }
                                                            },
                                                            "type": "object",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object"
                                                },
                                                "type": "array",
                                                "nullable": true
                                            }
                                        },
                                        "type": "object",
                                        "nullable": true
                                    },
                                    "paths": {
                                        "items": {
                                            "type": "string"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    },
                                    "strict": {
                                        "type": "boolean",
                                        "nullable": true
                                    },
                                    "valuesFrom": {
                                        "items": {
                                            "properties": {
                                                "configMapRef": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "downwardAPI": {
                                                    "properties": {
                                                        "items": {
                                                            "items": {
                                                                "properties": {
                                                                    "fieldPath": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    },
                                                                    "kappControllerVersion": {
                                                                        "properties": {
                                                                            "version": {
                                                                                "type": "string",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "kubernetesAPIs": {
                                                                        "properties": {
                                                                            "groupVersions": {
                                                                                "items": {
                                                                                    "type": "string"
                                                                                },
                                                                                "type": "array",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "kubernetesVersion": {
                                                                        "properties": {
                                                                            "version": {
                                                                                "type": "string",
                                                                                "nullable": true
                                                                            }
                                                                        },
                                                                        "type": "object",
                                                                        "nullable": true
                                                                    },
                                                                    "name": {
                                                                        "type": "string",
                                                                        "nullable": true
                                                                    }
                                                                },
                                                                "type": "object"
                                                            },
                                                            "type": "array",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                },
                                                "path": {
                                                    "type": "string",
                                                    "nullable": true
                                                },
                                                "secretRef": {
                                                    "properties": {
                                                        "name": {
                                                            "type": "string",
                                                            "nullable": true
                                                        }
                                                    },
                                                    "type": "object",
                                                    "nullable": true
                                                }
                                            },
                                            "type": "object"
                                        },
                                        "type": "array",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                }
            },
            "type": "object"
        },
        "status": {
            "properties": {
                "conditions": {
                    "items": {
                        "properties": {
                            "message": {
                                "type": "string",
                                "nullable": true
                            },
                            "reason": {
                                "type": "string",
                                "nullable": true
                            },
                            "status": {
                                "type": "string"
                            },
                            "type": {
                                "type": "string"
                            }
                        },
                        "required": [
                            "status",
                            "type"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "consecutiveReconcileFailures": {
                    "type": "integer",
                    "nullable": true
                },
                "consecutiveReconcileSuccesses": {
                    "type": "integer",
                    "nullable": true
                },
                "deploy": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "finished": {
                            "type": "boolean",
                            "nullable": true
                        },
                        "kapp": {
                            "properties": {
                                "associatedResources": {
                                    "properties": {
                                        "groupKinds": {
                                            "items": {
                                                "properties": {
                                                    "group": {
                                                        "type": "string"
                                                    },
                                                    "kind": {
                                                        "type": "string"
                                                    }
                                                },
                                                "required": [
                                                    "group",
                                                    "kind"
                                                ],
                                                "type": "object"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        },
                                        "label": {
                                            "type": "string",
                                            "nullable": true
                                        },
                                        "namespaces": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "startedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "stdout": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "fetch": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "startedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "stdout": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "friendlyDescription": {
                    "type": "string",
                    "nullable": true
                },
                "inspect": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "stdout": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "managedAppName": {
                    "type": "string",
                    "nullable": true
                },
                "observedGeneration": {
                    "format": "int64",
                    "type": "integer",
                    "nullable": true
                },
                "template": {
                    "properties": {
                        "error": {
                            "type": "string",
                            "nullable": true
                        },
                        "exitCode": {
                            "type": "integer",
                            "nullable": true
                        },
                        "stderr": {
                            "type": "string",
                            "nullable": true
                        },
                        "updatedAt": {
                            "format": "date-time",
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "usefulErrorMessage": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object",
            "nullable": true
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
/**
 * An App is a set of Kubernetes resources. These resources could span any number of namespaces or could be cluster-wide (e.g. CRDs). An App is represented in kapp-controller using a App CR. The App CR comprises of three main sections: spec.fetch – declare source for fetching configuration and OCI images spec.template – declare templating tool and values spec.deploy – declare deployment tool and any deploy specific configuration
 */
export class App extends Model {
    constructor(data) {
        super({
            apiVersion: App.apiVersion,
            kind: App.kind,
            ...data
        });
    }
}
App.apiVersion = "kappctrl.k14s.io/v1alpha1";
App.kind = "App";
App.is = createTypeMetaGuard(App);
setSchema(App, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
